﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Volga_IT_17_Soldatkin_Editor
{
    public class Field
    {
        public int Width { get; set; }
        public int Height { get; set; }
        public List<Creature> Creatures { get; set; }
        public Player Player { get; set; }

        public void InitEmpty(int w, int h)
        {
            Width = w;
            Height = h;
            Creatures = new List<Creature>();
            Player = new Player();
            Creatures.Add(Player);
        }

        public IEnumerable<KeyValuePair<int, int>> AllPositions
        {
            get
            {
                for (int row = 0; row < Height; row++)
                {
                    for (int column = 0; column < Width; column++)
                    {
                        yield return new KeyValuePair<int, int>(row, column);
                    }
                }
            }
        }

        public bool IsPositionFree(int row, int column)
        {
            return GetCreatureAt(row, column) == null;
        }

        public Creature GetCreatureAt(int row, int column)
        {
            return Creatures.FirstOrDefault(c => c.Row == row && c.Column == column);
        }
    }

    public class Enemy : Creature
    {
    }

    public class Player : Creature
    {
    }

    public class Creature
    {
        public int Force { get; set; }
        public int Row { get; set; }
        public int Column { get; set; }
    }
}
