﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Volga_IT_17_Soldatkin
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            MainManager.Instance.BattleStateChanged += OnBattleStateChanged;
            Render.Instance.Init(pictureBox1);
            
            string pathDifficulities = Directory.GetCurrentDirectory();
            pathDifficulities = Path.Combine(pathDifficulities, "Difficulities");

            if (!Directory.Exists(pathDifficulities))
            {
                Directory.CreateDirectory(pathDifficulities);

                Difficulity d1 = new Difficulity();
                d1.SizeX = 5;
                d1.SizeY = 5;
                d1.EnemyForceLimit = 4;
                d1.MaxGeneratingEnemy = 1;
                File.WriteAllText(Path.Combine(pathDifficulities, "1_Easy"), d1.Serialize(), Encoding.ASCII);

                Difficulity d2 = new Difficulity();
                d2.SizeX = 7;
                d2.SizeY = 7;
                d2.EnemyForceLimit = 10;
                d2.MaxGeneratingEnemy = 3;
                File.WriteAllText(Path.Combine(pathDifficulities, "2_Medium"), d2.Serialize(), Encoding.ASCII);

                Difficulity d3 = new Difficulity();
                d3.SizeX = 10;
                d3.SizeY = 10;
                d3.EnemyForceLimit = 20;
                d3.MaxGeneratingEnemy = 5;
                File.WriteAllText(Path.Combine(pathDifficulities, "3_Hard"), d3.Serialize(), Encoding.ASCII);
            }

            string[] difficulityFiles = Directory.GetFiles(pathDifficulities);

            if (difficulityFiles.Length < 1)
            {
                MessageBox.Show("Не найдено ни 1 файла сложности");
                Environment.Exit(0);
                return;
            }

            Array.Sort(difficulityFiles);
            MainManager.Instance.Difficulities = new Dictionary<string, Difficulity>();

            foreach (var file in difficulityFiles)
            {
                string content = File.ReadAllText(file, Encoding.ASCII);
                Difficulity d1 = new Difficulity();
                d1.Parse(content);
                string key = Path.GetFileName(file);
                MainManager.Instance.Difficulities.Add(key, d1);
                comboBoxDifficulity.Items.Add(key);
            }

            MainManager.Instance.SelectedDifficulity = MainManager.Instance.Difficulities.ElementAt(0).Value;
            comboBoxDifficulity.SelectedItem = MainManager.Instance.Difficulities.ElementAt(0).Key;

            NewGame();
        }

        private void OnBattleStateChanged()
        {
            if (MainManager.Instance.Field.IsWin)
            {
                MessageBox.Show("Победа! :)");
                return;
            }

            if (MainManager.Instance.Field.IsDefeat)
            {
                MessageBox.Show("Поражение! :C");
                return;
            }
        }

        private void buttonNewGame_Click(object sender, EventArgs e)
        {
            NewGame();
        }

        private void NewGame()
        {
            MainManager.Instance.CurrentGameDifficlulity = MainManager.Instance.SelectedDifficulity;

            MainManager.Instance.Field = new Field();
            MainManager.Instance.Field.InitEmpty(MainManager.Instance.CurrentGameDifficlulity.SizeX, MainManager.Instance.CurrentGameDifficlulity.SizeY);
            MainManager.Instance.Field.CreateRandimEnemyOnTurn();
            MainManager.Instance.RaiseFieldChanged();
        }

        private void SaveExample(string path)
        {
            // Потому что не знаю как в блокноте делать ASCII
            StringBuilder b = new StringBuilder();
            b.AppendLine("5 5");
            b.AppendLine("0 0 0 4");
            b.AppendLine("2 2 1");
            b.AppendLine("3 4 0");
            b.AppendLine("0 1 2");
            b.AppendLine("3 0 0");
            File.WriteAllText(path, b.ToString(), Encoding.ASCII);
        }

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            //SaveExample(@"C:\Users\user\Documents\Visual Studio 2013\Projects\УУУ какой файл.txt");
            openFileDialog1.ShowDialog();
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            MainManager.Instance.Loader.Load(openFileDialog1.FileName);
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            int dx = 0;
            int dy = 0;

            switch(e.KeyCode)
            {
                case Keys.A:
                    dx--;
                    break;

                case Keys.D:
                    dx++;
                    break;

                case Keys.W:
                    dy--;
                    break;

                case Keys.S:
                    dy++;
                    break;
            }

            int toX = MainManager.Instance.Field.Player.Column + dx;
            int toY = MainManager.Instance.Field.Player.Row + dy;
            MainManager.Instance.Field.TryMovePlayerTo(toY, toX);
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            saveFileDialog1.ShowDialog();
        }

        private void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            MainManager.Instance.Loader.Save(saveFileDialog1.FileName);
        }

        private void comboBoxDifficulity_SelectedValueChanged(object sender, EventArgs e)
        {
            MainManager.Instance.SelectedDifficulity = MainManager.Instance.Difficulities[comboBoxDifficulity.Text];
        }

        Thread botThread;

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                botThread = new Thread(BotLoop);
                botThread.Start();
            }
            else
            {
                if (botThread != null)
                {
                    botThread.Abort();
                }
            }
        }

        // К сожалению волновой и тем более A* не успею :(
        private void BotLoop()
        {
            bool moved = true;

            while (true)
            {
                var f = MainManager.Instance.Field;
                
                var target = f.Creatures.FirstOrDefault(c => c.Force == f.Player.Force && c != f.Player);

                if (target != null || !moved)
                {
                    int dx = 0;
                    int dy = 0;

                    if (target.Column < f.Player.Column)
                        dx = -1;

                    if (target.Column > f.Player.Column)
                        dx = 1;

                    if (target.Row > f.Player.Row)
                        dy = 1;

                    if (target.Row < f.Player.Row)
                        dy = -1;

                    if (dx != 0)
                    {
                        int nPosX = f.Player.Column + dx;
                        int nPosY = f.Player.Row;
                        f.TryMovePlayerTo(nPosY, nPosX);
                        if (f.Player.Row == nPosY && f.Player.Column == nPosX)
                            moved = true;
                        else
                            moved = false;
                    }
                    else
                    {
                        int nPosX = f.Player.Column;
                        int nPosY = f.Player.Row + dy;
                        f.TryMovePlayerTo(nPosY, nPosX);
                        if (f.Player.Row == nPosY && f.Player.Column == nPosX)
                            moved = true;
                        else
                            moved = false;
                    }
                }
                else
                {
                    int dx = 0;
                    int dy = 0;

                    if (MainManager.Instance.Random.Next(0, 2) == 0)
                    {
                        if (MainManager.Instance.Random.Next(0, 2) == 0)
                            dx--;
                        else
                            dx++;
                    }
                    else
                    {
                        if (MainManager.Instance.Random.Next(0, 2) == 0)
                            dy--;
                        else
                            dy++;
                    }

                    int nPosX = f.Player.Column + dx;
                    int nPosY = f.Player.Row + dy;
                    f.TryMovePlayerTo(nPosY, nPosX);
                    if (f.Player.Row == nPosY && f.Player.Column == nPosX)
                        moved = true;
                    else
                        moved = false;
                }

                Thread.Sleep(1000);
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (botThread != null)
            {
                botThread.Abort();
            }
        }
    }
}
